#pragma once
#include <initializer_list>

template <typename T>
struct WArray {
 public:
  int capacity;
  int sz;
  T* arr;
  //typedef typename array_type::iterator iterator;
  //typedef typename array_type::const_iterator const_iterator;
  typedef const T* iterator;
  typedef const T* const_iterator;
  //iterator _M_array;

  constexpr int size() const noexcept { return sz; }
  constexpr const_iterator begin() const noexcept { return &arr[0]; }
  constexpr const_iterator end() const noexcept { return &arr[sz]; }

	T operator[](int i) const { return arr[i]; }
  T& operator[](int i) { return arr[i]; }
  //inline const_iterator cbegin() const noexcept { return vec.cbegin(); }
  //inline iterator end() noexcept { return vec.end(); }
  //inline const_iterator cend() const noexcept { return vec.cend(); }
  WArray() {
    sz = 0;
    capacity = 0;
  }
  //Array(T* _arr, int cnt, int capacity = 0) { 
  WArray(std::initializer_list<T> _arr, int capacity = 0) {
    sz = _arr.size();

    if (capacity == 0) {
      capacity = sz;
    }

    this->arr = new T[capacity];

    int i = 0;
    for (T elem : _arr) {
      this->arr[i] = elem;
      i++;
    }
  }
  void add(T elem) { this->arr[sz++] = elem;
  }
};
