﻿#pragma once


void Engine::init_tracer(VarsCloudTracer& v) {
	v.prog_clean_dbg = new ShaderProgram(
		{
			new Shader("engine/clean_dbg.comp")
		}
	);

	v.hdri_tex = WEngine->alloc_textures.push(std::string("src/assets/hdri/aristea_wreck_puresky_4k.hdr")).ptr;

	// ShaderProgram* prog_post;
}


// void Engine::init_game(Vars& v) {
//
// 	text_drawer = new TextDrawer(v.font);
// 	v.font = new Font(std::string("Vintage_Stylist.otf"));
// 	this->scene_model = this->alloc_scenes.push("assets\\models\\cube2.glb").ptr;
// 	wlog_warn("-- SCENE LOADING FINISHED --");
//
// 	// for (int i = 0; i < 10; i++) {
// 	// 	// shadow_map_textures.push_back(new Framebuffer(nullptr, false, false, n))
// 	// 	shadow_map_textures.push_back(
// 	// 		new Framebuffer({
// 	// 			WArray<Texture*>({}), false, false,
// 	// 			WEngine->alloc_textures.push(TextureDesc{1024, 1024, 1, InternalFormat::DEPTH_COMPONENT24}).ptr
// 	// 		})
// 	// 	);
// 	// }
//
// 	wlog_warn("-- SHADOW MAP TEXTURES ALLOC FINISHED --");
//
//
// 	// TextDescriptor text_test = {
// 	// 	.text = "Text\n"
// 	// 	"rendering\n"
// 	// 	"is\n"
// 	// 	"actually\n"
// 	// 	"not\n"
// 	// 	"the\n"
// 	// 	"hardest\n"
// 	// 	"but\n"
// 	// 	"not extremely easy."
// 	// };
//
//
// 	// WAlloc allocator = WAlloc<GameObject, 10000>;
//
// 	// ------ AUDIO ------ //
// 	// ------ AUDIO ------ //
// 	// ------ AUDIO ------ //
// 	// ------ AUDIO ------ //
// 	// ------ AUDIO ------ //
// 	// ------ AUDIO ------ //
// 	// IPLContextSettings contextSettings{};
// 	// contextSettings.version = STEAMAUDIO_VERSION;
// 	//
// 	// IPLContext context = nullptr;
// 	// iplContextCreate(&contextSettings, &context);
//
// 	this->audio_mixer->set_master_volume(0.0f);
// 	{
// 		for (int i = 0; i < 5; i++) {
// 			std::string name = "src/assets/sounds/sfx/player_step_";
// 			name = name + std::to_string(i);
// 			name = name + ".wav";
// 			v.audio_footsteps[i] = new AudioFile(&audio_mixer->engine, name, {.sound_group = &audio_mixer->sfx_sound_group});
// 		}
//
//
// 		v.audio_pickup = new AudioFile(&audio_mixer->engine, "src/assets/sounds/hl2/ui/buttonclickrelease.wav",
// 			{.sound_group = &audio_mixer->sfx_sound_group});
// 		v.audio_obj_fall = new AudioFile(
// 			&audio_mixer->engine,
// 			"src/assets/sounds/hl2/physics/surfaces/sand_impact_bullet1.wav",
// 			{.sound_group = &audio_mixer->sfx_sound_group, .spatialization_enabled = true}
// 			// NULL,
// 			// true
// 		);
//
//
// 		// ------ CREATE GAME OBJECTS ------ //
// 		v.audio_positions = {
// 			this->scene_model->parent_node->children_map["_AudioPos.000"]->position,
// 			this->scene_model->parent_node->children_map["_AudioPos.001"]->position,
// 			this->scene_model->parent_node->children_map["_AudioPos.002"]->position,
// 			this->scene_model->parent_node->children_map["_AudioPos.003"]->position,
// 			this->scene_model->parent_node->children_map["_AudioPos.004"]->position,
// 			this->scene_model->parent_node->children_map["_AudioPos.005"]->position,
// 			this->scene_model->parent_node->children_map["_AudioPos.006"]->position,
// 			this->scene_model->parent_node->children_map["_AudioPos.007"]->position
// 		};
//
// 		v.audio_files = {
// 			new AudioFile(&audio_mixer->engine, "src/assets/sounds/music/track-a.wav"),
// 			new AudioFile(&audio_mixer->engine, "src/assets/sounds/music/track-a 4-Audio.wav"),
// 			new AudioFile(&audio_mixer->engine, "src/assets/sounds/music/track-a 5-Audio.wav"),
// 			new AudioFile(&audio_mixer->engine, "src/assets/sounds/music/track-a 6-Loom_x64.wav"),
// 			new AudioFile(&audio_mixer->engine, "src/assets/sounds/music/track-a 7-Box Break 5.wav"),
// 			new AudioFile(&audio_mixer->engine, "src/assets/sounds/music/track-a 8-Let Roll Bass.wav"),
// 			new AudioFile(&audio_mixer->engine, "src/assets/sounds/music/track-a 9-Meltdown Beep.wav"),
// 			new AudioFile(&audio_mixer->engine, "src/assets/sounds/music/track-a 10-909KICK2.wav"),
// 			new AudioFile(&audio_mixer->engine, "src/assets/sounds/music/track-a 11-CLAP_TEARS.wav")
// 		};
// 		for (auto audio_file : v.audio_files) {
// 			audio_file->set_looping_enabled(true);
// 			audio_file->start();
// 			audio_file->set_volume(0.05);
// 		}
// 	}
//
// 	wlog_warn("-- AUDIO INIT FINISHED --");
//
// 	// ------- SHADERS INIT ------- //
// 	// ------- SHADERS INIT ------- //
// 	// ------- SHADERS INIT ------- //
// 	// ------- SHADERS INIT ------- //
// 	// ------- SHADERS INIT ------- //
//
// 	// ShaderProgram* prog_gi_frag = new ShaderProgram(
// 	// 	{
// 	// 		 vert_sh_fullscreen_quad,
// 	// 	new Shader((char*)"gi.frag", ShaderType::Fragment)
// 	// 	});
//
// 	v.prog_clean_dbg = new ShaderProgram(
// 		{
// 			new Shader("engine/clean_dbg.comp")
// 		}
// 	);
// 	v.prog_gi_comp = new ShaderProgram({new Shader("gi.comp")});
// 	v.prog_di = new ShaderProgram({
// 			vert_sh_fullscreen_quad,
// 			new Shader("di.frag")
// 		}
// 	);
// 	v.prog_add_gi_and_di = new ShaderProgram({
// 			vert_sh_fullscreen_quad,
// 			new Shader("add_gi_and_di.frag")
// 		}
// 	);
// 	v.prog_gi_reproj = new ShaderProgram({
// 		vert_sh_fullscreen_quad,
// 		new Shader("gi_proj.frag")
// 	});
//
// 	v.prog_thing = new ShaderProgram({
// 		new Shader("thing.vert"),
// 		new Shader("thing.frag")
// 	}, true);
//
// 	// v.prog_trippy = new ShaderProgram({
// 	// 	new Shader("trippy.vert"),
// 	// 	new Shader("thing.frag")
// 	// }, true);
//
// 	// ShaderProgram* prog_march = new ShaderProgram({vert_sh_fullscreen_quad,
// 	// 	new Shader((char*)"raymarch.frag", ShaderType::Fragment)
// 	// });
// 	v.prog_taa = new ShaderProgram({
// 		vert_sh_fullscreen_quad,
// 		new Shader("taa.frag")
// 	});
// 	v.prog_post = new ShaderProgram({
// 		vert_sh_fullscreen_quad,
// 		new Shader("post.frag")
// 	});
//
//
// 	wlog_warn("-- SHADERS INIT FINISHED --");
//
//
// 	v.render_res_x = this->RESX;
// 	v.render_res_y = this->RESY;
//
// 	// ------- FRAMEBUFFERS ------- //
// 	// ------- FRAMEBUFFERS ------- //
// 	// ------- FRAMEBUFFERS ------- //
// 	// ------- FRAMEBUFFERS ------- //
// 	// ------- FRAMEBUFFERS ------- //
// 	// ------- FRAMEBUFFERS ------- //
//
// 	// Texture* back_depth = new Texture(render_res_x, render_res_y, 1u, depth_format);
//
// 	// WEngine->alloc_textures.push(TextureDesc
// 	{
// 		v.fb_G = new Framebuffer({
// 			WArray({
// 				// new Texture({render_res_x, render_res_y, 1u, InternalFormat::RGBA16F}),
// 				WEngine->alloc_textures.push(TextureDesc{v.render_res_x, v.render_res_y, 1u, InternalFormat::RGBA8}).ptr,
// 				WEngine->alloc_textures.push(TextureDesc{v.render_res_x, v.render_res_y, 1u, InternalFormat::RG16UI}).ptr,
// 				WEngine->alloc_textures.push(TextureDesc{v.render_res_x, v.render_res_y, 1u, InternalFormat::RG16F}).ptr,
// 			}),
// 			true, true,
// 			WEngine->alloc_textures.push(TextureDesc{v.render_res_x, v.render_res_y, 1u, v.depth_format}).ptr,
// 			false,
// 			"G Buff"
// 		});
//
// 		// InternalFormat gi_internal_format = InternalFormat::R11F_G11F_B10F;
// 		// InternalFormat gi_internal_format = InternalFormat::RGBA16F;
// 		v.fb_GI = new Framebuffer({
// 			WArray({
// 				WEngine->alloc_textures.push(TextureDesc{
// 					.resx = v.render_res_x,
// 					.resy = v.render_res_y,
// 					.resz = 1u,
// 					.internal_format = v.gi_internal_format,
// 					.tex_access = TexAccess::RW
// 				}).ptr,
// 			}),
// 			false, false,
// 			nullptr, false,
// 			"FB GI"
// 		});
//
// 		v.fb_DI = new Framebuffer({
// 			WArray({
// 				WEngine->alloc_textures.push(TextureDesc{v.render_res_x, v.render_res_y, 1u, v.gi_internal_format}).ptr,
// 			}),
// 			true, true,
// 			nullptr, false,
// 			"DI Buff"
// 		});
//
// 		v.fb_GI_plus_DI = new Framebuffer({
// 			WArray({
// 				WEngine->alloc_textures.push(TextureDesc{v.render_res_x, v.render_res_y, 1u, v.gi_internal_format}).ptr,
// 			}),
// 			false, false,
// 			nullptr, false,
// 			"GI+DI Buff"
// 		});
//
//
// 		v.fb_GI_reproj = new Framebuffer({
// 			WArray({
// 				WEngine->alloc_textures.push(TextureDesc{
// 					.resx = v.render_res_x,
// 					.resy = v.render_res_y,
// 					.resz = 1u,
// 					.internal_format = v.gi_internal_format,
// 					.tex_access = TexAccess::RW
// 				}).ptr,
// 			}),
// 			false, false, nullptr, false,
// 			"GI Reproj Buff"
// 		});
//
// 		v.prev_frame_gi_tex = WEngine->alloc_textures.push(TextureDesc{
// 			.resx = v.render_res_x,
// 			.resy = v.render_res_y,
// 			.resz = 1u,
// 			.internal_format = v.gi_internal_format,
// 			.tex_access = TexAccess::RW
// 		}).ptr;
// 		v.prev_frame_gi_tex->set_name("Prev Frame GI Tex");
// 		// v.prev_frame_gi_tex->name = "Prev Frame GI Tex";
//
// 		v.fb_taa = new Framebuffer({
// 			WArray({
// 				// new Texture({this->RESX, this->RESY, 1u, InternalFormat::RGBA32F})
// 				WEngine->alloc_textures.push(TextureDesc{this->RESX, this->RESY, 1u, v.gi_internal_format}).ptr
// 			}),
// 			true, true, nullptr, false, "TAA Buff"
// 		});
//
// 	}
//
// 	v.hdri_tex = WEngine->alloc_textures.push(std::string("src/assets/hdri/aristea_wreck_puresky_4k.hdr")).ptr;
//
// 	// PassBloom* pass_bloom = new PassBloom(v.fb_taa);
//
//
// 	// ------- UI INIT -------- //
// 	// ------- UI INIT -------- //
// 	// ------- UI INIT -------- //
// 	// ------- UI INIT -------- //
// 	// ------- UI INIT -------- //
// 	v.start_menu = new StartMenu(text_drawer);
//
//
// 	// std::cout << "-- UI INIT FINISHED -- \n";
//
// 	// ------- SCENE & MODELS -------- //
// 	// ------- SCENE & MODELS -------- //
// 	// ------- SCENE & MODELS -------- //
// 	// ------- SCENE & MODELS -------- //
// 	// ------- SCENE & MODELS -------- //
//
//
// 	// allocator.push(GameObject(nullptr, PhysicsCreationInfo().set_physics_enabled(false)));
// 	// alloc_game_object.push(nullptr, PhysicsCreationInfo().set_physics_enabled(false)).ptr;
//
//
// 	// physics_creation_info.collision_shape = new JPH::SphereShape(0.1f);
//
// 	// v.trippy_obj = alloc_game_object.
// 	// 	push(v.prog_trippy, PhysicsCreationInfo().set_physics_enabled(false)
// 	// );
//
// 	// int vert_cnt = 100;
// 	// editor->add_gui_control("vert cnt", &vert_cnt, {.range_min = 0, .range_max = 10000});
// 	// v.trippy_obj.get()->render_function = [&, this](float a, float b, float c, float d, float e, float f) {
// 	// 	// glEnabl
// 	// 	vert_feedback_buff_idx = frame % 2;
// 	// 	Buffer* buff_front = vert_feedback_buff_idx == 0 ? vert_feedback_buff : vert_feedback_buff_other;
// 	// 	Buffer* buff_back = vert_feedback_buff_idx == 1 ? vert_feedback_buff : vert_feedback_buff_other;
// 	//
// 	// 	WEntity* _trippy_obj = v.trippy_obj.get();
// 	// 	// auto shader_prog = _trippy_obj->shader_prog;
// 	//
// 	// 	ShaderProgram* shader_p = _trippy_obj->shader_prog;
// 	// 	if(f > 0.0) {
// 	// 		if(shader_p->shadow_map_variation) {
// 	// 			shader_p = shader_p->shadow_map_variation;
// 	// 		}
// 	// 	}
// 	//
// 	// 	shader_p->use();
// 	//
// 	// 	shader_p->setUniform("buff_front", buff_front);
// 	// 	shader_p->setUniform("buff_back", buff_back);
// 	// 	shader_p->setUniform("mat", _trippy_obj->matrix);
// 	// 	shader_p->setUniform("prev_mat", _trippy_obj->prev_matrix);
// 	// 	shader_p->setUniform("rot_mat", _trippy_obj->rot_matrix);
// 	// 	// int elem_cnt = indices_buff->elem_cnt;
// 	// 	// elem_cnt = 16;
// 	// 	glDrawArrays(GL_TRIANGLES, 0, vert_cnt);
// 	// 	// glDrawArrays(GL_TRIANGLES, 0, 0);
// 	// };
//
//
// 	int vert_feedback_buff_byte_len = 2000;
// 	int vert_feedback_buff_idx = 0;
//
// 	// Buffer* vert_feedback_buff = new Buffer(new char8_t[vert_feedback_buff_byte_len], vert_feedback_buff_byte_len);
// 	// Buffer* vert_feedback_buff_other = new Buffer(new char8_t[vert_feedback_buff_byte_len], vert_feedback_buff_byte_len);
//
//
// 	// WEngine->editor->gui_dbg_notif_msg(str.c_str());
// 	// audio_obj_fall->start(-1, 1.0f - 1.0f/(1.0f + len*2.5f), me->get_pos());
//
//
// 	// this->lights.push_back(light_sun);
//
// 	// Light* pt_light = alloc_lights.push(LightDesc{2048, 2048, LightType::POINT});
// 	// pt_light->pos = player_start_pos;
// 	// pt_light->pos.y = 3.260f;
// 	// pt_light->near_plane = 0.001f;
//
// }
//
//
// __declspec(noinline) void Engine::eloop(Vars& v) {
//
// 	ZoneScopedN("LOOP");
// 	// Sleep(1000);
//
// 	auto restart_player = [&]() {
// 		v.player->set_pos(v.player_start_pos);
// 		v.player->set_vel(glm::vec3(0,0,0));
// 		camera->pitch_yaw_roll.x = 0.0f;
// 		camera->pitch_yaw_roll.y = -0.5f;
// 		// camera->pitch_yaw_roll.y = 0.0f;
// 		// v.player->set_rot(
// 		// 	 glm::quatLookAt(
// 		// 	 	glm::normalize(
// 		// 	 		glm::vec3(-1.0f, 0.0f, 0.0f)
// 		// 	 		),
// 		// 	 	glm::vec3(0, 1, 0)
// 		// ));
// 		v.score = 0.0f;
// 	};
//
//
// 	auto score_text = TextDescriptor{
// 		.pos = glm::vec2(0.0, 0.7),
// 		.col = glm::vec4(1, 1, 1, 1),
// 		.sz = 0.4f,
// 		.kern_scale = 1.0f,
// 		.text = "125"
// 	};
//
// 	if (this->initializing) {
// 		ZoneScopedN("re-init");
// 		wlog_info("-- RE-INITIALIZING -- ");
//
// 		// ------ CREATE GAME OBJECTS ------ //
// 		// ------ CREATE GAME OBJECTS ------ //
// 		// ------ CREATE GAME OBJECTS ------ //
// 		// ------ CREATE GAME OBJECTS ------ //
// 		// ------ CREATE GAME OBJECTS ------ //
// 		// ------ CREATE GAME OBJECTS ------ //
// 		{
// 			// physics.body_interface->DestroyBodies()
// 			for (auto& child : scene_model->parent_node->children_map) {
// 				const std::string name = child.first;
// 				ModelNode* model = child.second;
// 				bool valid = true;
// 				bool is_prefab = name.at(0) == '_';
// 				if (is_prefab) {
// 					valid = false;
// 				}
// 				if (!is_prefab) {
// 					if (model->children.size() <= 0 && model->meshes.size() <= 0) {
// 						valid = false;
// 					}
//
// 				}
// 				if (valid) {
// 					auto game_object = alloc_game_object.push(
// 						model,
// 						v.prog_thing
// 						// PhysicsCreationInfo()
// 					).ptr;
//
// 					// game_object->render_function = [game_object](
// 					// 	float a, float b, float c, float d, float e, float f) {
// 					// 		ShaderProgram* shader_p = game_object->shader_prog;
// 					// 		if (f > 0.0) {
// 					// 			if (game_object->shader_prog->shadow_map_variation) {
// 					// 				shader_p = game_object->shader_prog->shadow_map_variation;
// 					// 			}
// 					// 		}
// 					//
// 					// 		shader_p->use();
// 					// 		shader_p->setUniform("rot_mat", game_object->rot_matrix);
// 					//
// 					// 		for (auto mesh : game_object->model_node->meshes) {
// 					// 			auto indices_buff = mesh->buff_vert_indices;
// 					// 			auto verts_buff = mesh->bufF_verts;
// 					// 			auto texcoords_buff = mesh->buff_tex_coords;
// 					// 			auto normals_buff = mesh->buff_normals;
// 					//
// 					// 			shader_p->setUniform("indices_buff", indices_buff);
// 					// 			shader_p->setUniform("verts_buff", verts_buff);
// 					// 			shader_p->setUniform("texcoords_buff", texcoords_buff);
// 					// 			shader_p->setUniform("normals_buff", normals_buff);
// 					// 			if (mesh->textures.size() > 0) {
// 					// 				shader_p->setUniform("tex_albedo", mesh->textures[0]);
// 					// 				shader_p->setUniform("has_albedo_tex", true);
// 					// 			} else {
// 					// 				shader_p->setUniform("has_albedo_tex", false);
// 					// 			}
// 					// 			shader_p->setUniform("mat", game_object->matrix);
// 					// 			shader_p->setUniform("prev_mat", game_object->prev_matrix);
// 					// 			//
// 					// 			shader_p->setUniform("has_texcoords", texcoords_buff != nullptr);
// 					// 			//
// 					// 			// int elem_cnt = indices_buff->elem_cnt / 3 ;
// 					// 			int elem_cnt = indices_buff->elem_cnt;
// 					// 			// elem_cnt = 16;
// 					// 			glDrawArrays(GL_TRIANGLES, 0, elem_cnt);
// 					// 		}
// 					// 	};
// 				}
// 			}
//
// 			wlog_info("-- INITIALIZED OBJECTS -- ");
// 			v.light_sun = alloc_lights.push(LightDesc{2048, 2048, LightType::DIRECTIONAL}).ptr;
// 			v.light_sun->dir = glm::normalize(glm::vec3(1));
//
// 			for (aiLight ai_light : scene_model->lights) {
// 				LightType light_type;
// 				switch (ai_light.mType) {
// 					case aiLightSource_DIRECTIONAL:
// 						light_type = LightType::DIRECTIONAL;
// 						break;
// 					case aiLightSource_POINT:
// 						light_type = LightType::POINT;
// 						break;
// 					case aiLightSource_SPOT:
// 						break;
// 					case aiLightSource_AMBIENT:
// 						break;
// 					case aiLightSource_AREA:
// 						break;
// 					case _aiLightSource_Force32Bit:
// 						break;
// 					default: ;
// 				}
// 				alloc_lights.push(LightDesc{
// 					.type = light_type,
// 					.intensity = ai_light.mAttenuationQuadratic,
// 					.colour = glm::vec3(ai_light.mColorDiffuse.r, ai_light.mColorDiffuse.g, ai_light.mColorDiffuse.b),
// 					.pos = glm::vec3(ai_light.mPosition.x, ai_light.mPosition.y, ai_light.mPosition.z),
// 					.target = glm::vec3(ai_light.mPosition.x, ai_light.mPosition.y, ai_light.mPosition.z),
// 					.dir = glm::vec3(ai_light.mDirection.x, ai_light.mDirection.y, ai_light.mDirection.z),
// 				}).ptr;
// 			}
// 			// std::cout << "-- INITIALIZED LIGHTS -- \n";
// 			wlog_warn("-- INITIALIZED LIGHTS --");
// 		}
//
// 		v.prefab_player = this->scene_model->parent_node->children_map["_Player"];
//
// 		v.player_start_pos = this->scene_model->parent_node->children_map["_PlayerStart"]->position;
// 		v.player = alloc_game_object.push(v.prefab_player, nullptr).ptr;
//
// 		v.prefab_ico = this->scene_model->parent_node->children_map["_Icosphere"];
// 		PhysicsCreationInfo physics_creation_info = PhysicsCreationInfo();
// 		physics_creation_info = physics_creation_info.set_gravity_factor(0.8);
//
// 		// v.ico_object = alloc_game_object.
// 		// 	push(v.prefab_ico, v.prog_thing, physics_creation_info
// 		// 	);
// 		//
// 		// v.ico_object.get()->col_sound = v.audio_obj_fall;
// 		//
// 		// v.ico_object.get()->obj_type = ObjType::IcosaTest;
//
// 		v.player->set_pos(v.player_start_pos);
// 		// v.ico_object.get()->set_pos(glm::vec3(0, 5, 0));
// 		// v.ico_object.get()->on_collision = [&](WCollision col) {};
//
// 		editor->add_gui_control("master vol", &audio_mixer->master_vol, {
// 			.range_min = 0., .range_max = 1.0, .precision = 0.01,
// 			.callback = [&]() { audio_mixer->set_master_volume(audio_mixer->master_vol); }
// 		});
//
// 		editor->add_gui_control("sfx vol", &audio_mixer->sfx_sound_group.vol, {
// 			.range_min = 0., .range_max = 1.0, .precision = 0.01,
// 			.callback = [&]() { audio_mixer->sfx_sound_group.set_volume(audio_mixer->sfx_sound_group.vol); }
// 		});
//
// 		editor->add_gui_control("music vol", &audio_mixer->default_sound_group.vol, {
// 			.range_min = 0., .range_max = 1.0, .precision = 0.01,
// 			.callback = [&]() { audio_mixer->default_sound_group.set_volume(audio_mixer->default_sound_group.vol); }
// 		});
//
//
// 		editor->add_gui_control("compute_subdiv", &v.compute_subdiv);
// 		editor->add_gui_control("add_prev_di_and_gi", &v.add_prev_di_and_gi);
//
// 		// editor->add_gui_control("tex anchor", &v.tex_anchor, {
// 		// 	.callback = [&]() {
// 		// 		text_test.anchor = TextAnchor(v.tex_anchor);
// 		// 	}
// 		// });
//
//
// 		editor->add_gui_control("camrot speed", &v.camrot_speed);
//
// 		editor->add_gui_control("taa jitt", &camera->taa_jitt_amt);
//
// 		editor->add_gui_control("light_sun", &v.light_sun->intensity);
// 		editor->add_gui_control("ambient_light", &this->ambient_light_intensity);
//
// 		WEngine->physics.physics_system->OptimizeBroadPhase();
//
// 		this->initializing = false;
// 	}
//
// 	// ------------------------------- //
// 	// ---------- GAME LOGIC --------- //
// 	// ------------------------------- //
// 	{
//
// 		ZoneScopedN("GAME LOGIC");
//
// 		if (io->get_key(Key::R).just_pressed) {
// 			restart_player();
// 		}
//
//
// 		v.score += delta_time;
// 		// physics.temp_allocator
// 		// editor->gui_dbg_print("Physics bodies cnt: ", );
//
// 		glm::vec3 player_pos = v.player->get_pos();
// 		glm::vec3 vel = v.player->get_vel();
//
// 		if (v.start_menu->toggled) {
// 			// io->mouse_grabbed = false;
// 			io->set_mouse_grabbed(false);
// 		} else {
// 			#ifndef EDITOR
// 			io->set_mouse_grabbed(true);
// 			#endif
// 		}
//
// 		editor->gui_dbg_print("player pos", player_pos);
// 		editor->gui_dbg_print("player vel", v.player->get_vel());
// 		editor->gui_dbg_print("mouse ndc", this->io->mouse_ndc);
// 		editor->gui_dbg_print("Velocity: ", vel);
//
// 		v.light_sun->target = player_pos;
//
// 		v.t_since_player_jump += delta_time;
// 		v.t_since_walljump += delta_time;
//
// 		auto carry_obj_logic = [&]() {
//
// 			if (io->mouse_lmb_just_pressed) {
// 				// -- throw
// 				if (v.carrying_object.ptr) {
// 					// carrying_object = WObj<WEntity>(0,0);
// 					v.carrying_object.get()->set_vel(camera->dir * 5.0f);
// 					v.carrying_object.clear();
// 					v.audio_pickup->start();
// 				}
// 			} else if (io->get_key(Key::E).just_pressed) {
// 				if (!v.carrying_object.ptr) {
// 					static RayCastResClosest ray_cast_res_forward;
//
// 					auto filter = JPH::IgnoreSingleBodyFilter(v.player->jph_body_id);
//
// 					ray_cast_res_forward = physics.RayCastClosest(
// 						camera->pos,
// 						glm::vec3(camera->dir * 10.0f),
// 						filter, {}, {}
// 					);
//
//
// 					glm::vec4 lcol = glm::vec4(1, 0, 0, 1);
//
// 					if (ray_cast_res_forward.hit) {
// 						// GameObject* game_obj = this->body_to_game_object[ray_cast_res_forward.body_id];
// 						WObj<WEntity> game_obj = WObj(this->body_to_game_object[ray_cast_res_forward.body_id]);
// 						WEntity* game_obj_ptr = game_obj.get();
//
// 						if (game_obj_ptr) {
// 							// BROKEN
// 							// if (game_obj_ptr->obj_type == ObjType::IcosaTest) {
// 							// 	v.audio_pickup->start();
// 							// 	v.carrying_object = game_obj;
// 							// 	lcol = 1.0f - lcol;
// 							// 	// drawer_3d->draw_line(
// 							// 	// 	{camera->pos + glm::vec3(0.05f, 0.1f, 0.0f), lcol},
// 							// 	// 	{ray_cast_res_forward.pos, glm::vec4(1, 1, 0, 1)}
// 							// 	// );
// 							// }
// 						}
// 					}
// 				} else {
// 					// -- put down
// 					v.carrying_object = WObj<WEntity>(0, 0);
// 					v.audio_pickup->start();
// 				}
//
// 			}
// 			if (v.carrying_object.ptr) {
// 				WEntity* game_obj = v.carrying_object.get();
// 				if (game_obj) {
// 					game_obj->set_pos(
// 						glm::mix(game_obj->position, camera->pos + camera->dir * 2.5f, float(delta_time * 10.0f))
// 					);
// 					game_obj->set_vel(glm::vec3(0.0f, 0.0f, 0.0f));
// 				}
// 			}
//
// 		};
//
// 		bool is_grounded = false;
// 		bool is_touching_wall = false;
//
// 		auto movement_logic = [&]() {
//
// 			// ground check
// 			{
// 				RayCastResClosest ray_cast_res_player_floor;
// 				auto filter = JPH::IgnoreSingleBodyFilter(v.player->jph_body_id);
// 				ray_cast_res_player_floor = physics.RayCastClosest(
// 					camera->pos,
// 					glm::vec3(0, -10, 0),
// 					filter, {}, {}
// 				);
// 				const float offs_d = 1.0f;
//
// 				auto do_heur = [](RayCastResClosest cast) {
// 					if (cast.hit && cast.dist < 1.2) {
// 						return true;
// 					} else {
// 						return false;
// 					}
// 				};
//
// 				if(!do_heur(ray_cast_res_player_floor)) {
// 					ray_cast_res_player_floor = physics.RayCastClosest(
// 						camera->pos,
// 						glm::vec3(offs_d, -10, offs_d),
// 						filter, {}, {}
// 					);
// 				}
// 				if(!do_heur(ray_cast_res_player_floor)) {
// 					ray_cast_res_player_floor = physics.RayCastClosest(
// 						camera->pos,
// 						glm::vec3(-offs_d, -10, offs_d),
// 						filter, {}, {}
// 					);
// 				}
// 				if(!do_heur(ray_cast_res_player_floor)) {
// 					ray_cast_res_player_floor = physics.RayCastClosest(
// 						camera->pos,
// 						glm::vec3(-offs_d, -10, -offs_d),
// 						filter, {}, {}
// 					);
// 				}
// 				if(!do_heur(ray_cast_res_player_floor)) {
// 					ray_cast_res_player_floor = physics.RayCastClosest(
// 						camera->pos,
// 						glm::vec3(offs_d, -10, -offs_d),
// 						filter, {}, {}
// 					);
// 				}
// 				// if()
//
// 				if(do_heur(ray_cast_res_player_floor)) {
// 					is_grounded = true;
// 				}
//
// 				// if (ray_cast_res_player_floor.hit && ray_cast_res_player_floor.dist < 1.2) {
// 				// }
// 			}
//
//
//
// 			float walk_speed = WEngine->delta_time * v.player_speed; // deltatime
//
// 			glm::vec2 keyInput = glm::vec2(0, 0);
// 			glm::vec3 walk_vec = glm::vec3(0);
// 			// get key input
// 			{
// 				if (WEngine->io->get_key(Key::A).down) {
// 																								 keyInput[0] -= 1;
// 																								 }
// 				if (WEngine->io->get_key(Key::D).down) {
// 																								 keyInput[0] += 1;
// 																								 }
// 				if (WEngine->io->get_key(Key::W).down) {
// 																								 keyInput[1] += 1;
// 																								 }
// 				if (WEngine->io->get_key(Key::S).down) { keyInput[1] -= 1; }
//
// 				glm::vec3 offs_vec = camera->dir * keyInput[1] + camera->right * keyInput[0];
// 				// offs_vec = glm::normalize(offs_vec);
// 				glm::vec2 horiz_mov;
// 				if(abs(keyInput[0]) > 0.01f && abs(keyInput[1]) > 0.01f) {
// 					horiz_mov = glm::normalize(
// 						glm::vec2(offs_vec.x, offs_vec.z)
// 					);
// 					offs_vec = glm::vec3( horiz_mov.x, offs_vec.y, horiz_mov.y );
// 				}
//
//
// 				walk_speed *= 2.0;
// 				// if (WEngine->io->get_key(Key::LShift).down) {
// 				// }
// 				walk_vec = walk_speed * offs_vec * glm::vec3(1, 0, 1);
// 			}
//
//
// 			// wall jump
// 			{
// 				RayCastResClosest cast_res;
// 				cast_res.dist = 10000000000.0f;
// 				cast_res.hit = false;
// 				static RayCastResClosest ray_cast_res_player_wall_left;
// 				static RayCastResClosest ray_cast_res_player_wall_right;
// 				auto filter = JPH::IgnoreSingleBodyFilter(v.player->jph_body_id);
//
// 				glm::vec3 right = camera->dir;
// 				right.y = 0.0f;
// 				right = glm::normalize(right) * 0.5f;
// 				right =	glm::angleAxis(float(pi)*-0.5f, glm::vec3(0,1,0)) * right ;
//
// 				glm::vec3 left = right * -1.0f;
//
//
// 				editor->gui_dbg_print("right", right);
// 				editor->add_gui_control("camfov", &camera->fov);
// 				// glm::vec3 right = camera->dir * glm::quat(0.0f, glm::vec3(0,1,0));
// 				// glm::vec3 right = camera->dir;
// 				bool wall_is_right = true;
//
// 				auto do_heur = [&](RayCastResClosest res, bool right) {
// 					if(res.hit && res.dist < cast_res.dist) {
// 						cast_res = res;
// 						wall_is_right = right;
// 					}
// 				};
//
// 				// ray_cast_res_player_wall_left = physics.RayCastClosest(
// 				// 	camera->pos, right, filter, {}, {}
// 				// );
// 				//
// 				// ray_cast_res_player_wall_right = physics.RayCastClosest(
// 				// 	camera->pos, left, filter, {}, {}
// 				// );
// 				const glm::vec3 vert_offs = glm::vec3(0.0f, 0.5f,0.0f);
//
// 				do_heur(physics.RayCastClosest( camera->pos, right, filter, {}, {} ), true);
// 				do_heur(physics.RayCastClosest( camera->pos, left, filter, {}, {} ), false);
// 				do_heur(physics.RayCastClosest( camera->pos, left + vert_offs, filter, {}, {} ), false);
// 				do_heur(physics.RayCastClosest( camera->pos, left - vert_offs, filter, {}, {} ), false);
// 				do_heur(physics.RayCastClosest( camera->pos, right + vert_offs, filter, {}, {} ), true);
// 				do_heur(physics.RayCastClosest( camera->pos, right - vert_offs, filter, {}, {} ), true);
//
// 				if (cast_res.hit) {
// 					is_touching_wall = true;
// 				}
//
// 				static float jv_ang;
// 				editor->add_gui_control("jump vec ang", &jv_ang);
//
// 				// walljump
// 				if(is_touching_wall && !is_grounded && v.t_since_player_jump > 0.05f) {
// 					if(v.t_since_walljump > 0.1f) {
// 						if(io->get_key(Key::Space).just_pressed) {
// 							// RayCastResClosest closest_cast;
// 							// {
// 							// 	closest_cast.dist = 10000.0f;
// 							// 	if(ray_cast_res_player_wall_left.hit && ray_cast_res_player_wall_left.dist < closest_cast.dist) {
// 							// 		closest_cast = ray_cast_res_player_wall_left;
// 							// 	}
// 							// 	if(ray_cast_res_player_wall_right.hit && ray_cast_res_player_wall_right.dist < closest_cast.dist) {
// 							// 		closest_cast = ray_cast_res_player_wall_right;
// 							// 	}
// 							// }
//
// 							if(glm::length(glm::vec2(cast_res.norm.x, cast_res.norm.z)) > 0.5f) {
// 								glm::vec3 player_vel = v.player->get_vel();
// 								player_vel += 0.01f;
// 								float in_vel_len = glm::length(player_vel);
//
// 								float lamb = glm::abs(glm::dot(player_vel, cast_res.norm));
// 								float fwd_fac = 1.0f;
//
// 								if(glm::abs(keyInput[0]) > 0.05f) {
// 									fwd_fac = 1.0f - fwd_fac;
// 								}
//
// 								float side_fac = 1.0f - fwd_fac;
//
//
//
// 								if(fwd_fac > 0.5f) {
// 									player_vel = glm::reflect(player_vel, cast_res.norm);
// 									player_vel = glm::normalize(player_vel) * (in_vel_len + 1.0f);
// 									player_vel += cast_res.norm * side_fac;
// 								} else {
// 									// player_vel
// 									// glm::vec3 refl_vec = glm::reflect(player_vel, closest_cast.norm);
// 									// float ang = glm::acos(glm::dot(glm::normalize(refl_vec), closest_cast.norm));
// 									// float delta_ang = (pi/2.0f) - ang;
// 									// refl_vec = glm::angleAxis(delta_ang, glm::vec3(0,1,0)) * refl_vec;
// 									glm::vec3 jump_vec = glm::normalize(camera->pos - cast_res.pos);
// 									// jump_vec = glm::angleAxis(jv_ang, glm::vec3(0,1,0)) * jump_vec;
// 									glm::vec2 xz = glm::vec2(jump_vec.x, jump_vec.z);
//
// 									xz = glm::rot_mat(
// 										// glm::dot(cast_res.norm,jump_vec)
// 										wall_is_right ? jv_ang : -jv_ang
// 									) * xz;
//
// 									jump_vec.x = xz.x;
// 									jump_vec.z = xz.y;
//
// 									// drawer_2d->push_vert({ camera->worldspace_to_ndc(camera->pos) });
// 									// drawer_2d->push_vert({ camera->worldspace_to_ndc(camera->pos + jump_vec) });
//
//
// 									player_vel = jump_vec * (in_vel_len + 1.0f)*1.0f;
// 									player_vel.y = 5.0f;
// 									// player_vel.y += (jump_vec.y);
//
// 								}
//
//
// 								if(side_fac > 0.5f){
// 									editor->gui_dbg_print_msg("side hit");
// 								}
// 								if(fwd_fac > 0.01f) {
// 									editor->gui_dbg_print_msg("fwd_fac");
// 									player_vel += glm::vec3(0.0f,4.0f,0.0f) * fwd_fac;
// 								}
//
//
//
// 								// player_vel = glm::reflect(player_vel, closest_cast.norm);
// 								// player_vel += glm::normalize(closest_cast.norm + glm::vec3(0,1,0))*1.5f;
// 								//
// 								// player_vel.y = glm::abs(player_vel.y);
// 								//
// 								// player_vel = glm::normalize(player_vel);
// 								// player_vel = player_vel * glm::max(in_vel_len*3.5f, 0.5f);
//
//
// 								// player_vel *= 2.0f;
//
// 								// if(player_vel.length() > 0.0f) {
// 								// 	player_vel = glm::normalize(player_vel)*1.0f;
// 								// }
// 								// player_vel += (closest_cast.norm + glm::vec3(0.0f,0.5f,0.0f))*5.0f;
// 								v.player->set_vel(player_vel);
// 								// ;
// 								// if(ray_cast_res_player_wall,)
// 							}
//
//
// 						}
//
// 					}
//
// 				}
//
//
//
// 				editor->gui_dbg_print("cam pos", camera->pos);
// 				editor->gui_dbg_print("right", right);
// 				editor->gui_dbg_print("res", cast_res.pos);
// 				editor->gui_dbg_print("hit", int(cast_res.hit));
//
// 				// glm::quat::
// 				// camera->dir
// 				// ray_cast_res_player_wall = physics.RayCastClosest(
// 				// 	camera->pos, glm::vec3(0, -10, 0), filter, {}, {}
// 				// );
//
// 				// drawer_3d->draw_line(
// 				// 	// {player_pos},
// 				// 	{.pos = camera->pos},
// 				// 	{.pos = ray_cast_res_player_wall.pos}
// 				// );
//
//
// 				// drawer_2d->push_vert({camera->worldspace_to_ndc(ray_cast_res_player_wall.pos)});
//
// 			}
//
// 			// feet shape cast test
// 			{
// 				// const RShapeCast &inShapeCast, const ShapeCastSettings &inShapeCastSettings,
//
//
// 				auto filter = JPH::IgnoreSingleBodyFilter(v.player->jph_body_id);
//
// 				// v.player.
//
// 				// auto a = JPH::BoxShapeSettings{};
// 				// // JPH:
// 				// new JPH::TransformedShape(
// 				// 	glm::to_jph( camera->pos + glm::vec3(0,1,0)),
// 				// 	JPH::Quat::sIdentity(),
// 				// 	new JPH::BoxShape( JPH::Vec3(1,1,1)),
// 				// );
// 				// RayCastResClosest shape_cast = physics.shape_cast_closest(
// 				// 	,
// 				// 	camera->pos + glm::vec3(0,1,0),
// 				// 	filter
// 				// );
// 				// if(shape_cast.hit) {
// 				// 	editor->gui_dbg_print("hit, hit dist", shape_cast.dist);
// 				// }
// 			}
//
// 			if (is_grounded && v.t_since_player_jump > 0.1f) {
// 				glm::vec3 player_vel = v.player->get_vel();
// 				player_vel.x *= 0.6 * delta_time;
// 				player_vel.z *= 0.6 * delta_time;
// 				v.player->set_vel(player_vel);
// 			}
// 			// ground jump
// 			if (WEngine->io->get_key(Key::Space).just_pressed && is_grounded && v.t_since_player_jump > 0.2) {
// 				glm::vec3 player_vel = v.player->get_vel();
// 				float jump_sp = 42.0f;
// 				player_vel.x = walk_vec.x * jump_sp;
// 				player_vel.z = walk_vec.z * jump_sp;
// 				player_vel.y = 5.0f;
// 				player_pos.y += 0.1f;
// 				v.player->set_vel(player_vel);
// 				v.t_since_player_jump = 0.0;
// 			}
//
// 			if (WEngine->io->mouse_grabbed && !camera->noclip) {
// 				// crouch
// 				{
// 					// groundslam
// 					if (io->get_key(Key::LCtrl).down){
// 						glm::vec3 vel = v.player->get_vel();
// 						vel.y = glm::mix(vel.y, -4.0f, float(delta_time*80.0f));
// 						vel.x = glm::mix(vel.x, vel.x*0.8f, float(delta_time*10.0f));
// 						vel.z = glm::mix(vel.z, vel.z*0.8f, float(delta_time*10.0f));
// 						// vel.x *= 0.999f * float(delta_time);
// 						// vel.z *= 0.999f * float(delta_time);
// 						v.player->set_vel(vel);
// 					}
// 					// if (io->get_key(Key::LCtrl).down) {
// 					// 																		v.crouching_amt = glm::mix(v.crouching_amt, 1.0f, 10.0f * delta_time);
// 					// 																		} else {
// 					// 	v.crouching_amt = glm::mix(v.crouching_amt, 0.0f, 20.0f * delta_time);
// 					// }
//
// 					// JPH::Ref<JPH::Shape> sh = v.player->collision_shape->ScaleShape(glm::to_jph(glm::vec3(1.0f,
// 					// 	1.0f - v.crouching_amt * 0.9f, 1.0f))).Get();
// 					// physics.body_interface->SetShape(v.player->jph_body_id, sh, false, JPH::EActivation::Activate);
// 				}
//
// 				// rot
// 				v.player->set_rot(
// 					glm::quatLookAt(glm::normalize(glm::vec3(camera->dir.x, 0., camera->dir.z)),
// 					glm::vec3(0, 1, 0))
// 				);
//
//
// 				// walk
// 				if (abs(keyInput.x) > 0.01 || abs(keyInput.y) > 0.01) {
// 					if(!is_grounded) {
// 						// air walk
// 						glm::vec3 player_vel = v.player->get_vel();
// 						// player_vel.y = 4.;
// 						// float player_vel_len = glm::length();
// 						// player_vel =
// 						// player_vel += walk_vec * float(delta_time)*1000.0f;
// 						if(glm::length(player_vel) > 0.05f) {
// 							player_vel = glm::normalize( player_vel ) * glm::clamp(glm::length(player_vel),0.0f,25.0f);
// 						}
// 						// player_vel = glm::min()
//
// 						v.player->set_vel(player_vel);
// 					} else {
// 						// glm::vec3 pos = v.player->get_pos();
// 						// player_pos += walk_vec;
// 						// vel += walk_vec * float(delta_time) * 10000.0f;
// 						player_pos += walk_vec * float(delta_time)* 80.0f;
// 						// v.player->set_pos(pos);
// 					}
// 					if (is_grounded) {
// 						const float dist_btw_footsteps = 0.95;
// 						v.dist_since_footstep += glm::length(walk_vec);
// 						if (v.dist_since_footstep > dist_btw_footsteps) {
// 							v.audio_footsteps[v.footstep_idx++]->start();
// 							v.footstep_idx = v.footstep_idx % 5;
// 							v.dist_since_footstep = 0.0;
// 						}
// 					}
// 					// camera->viewspace_offs.y = sin(v.dist_since_footstep * pi) * 0.025;
// 					camera->viewspace_offs = glm::vec2(0);
// 				}
//
// 			}
// 			if(is_grounded) {
// 				v.player->set_pos(player_pos);
// 			}
// 			if (!camera->noclip) {
// 				camera->pos = player_pos + glm::vec3(0.0f, 0.45f, 0.0f) - glm::vec3(0.0f, 0.35f * v.crouching_amt, 0.0f);
// 			}
// 		};
// 		auto audio_logic = [&]() {
// 			int i_audio_pos = 0;
//
// 			for (glm::vec3 audio_pos : v.audio_positions) {
// 				AudioFile* audio_file = v.audio_files[i_audio_pos++];
// 				float vol = 1.0 - glm::smoothstep(0.0f, 5.0f, glm::length(player_pos - audio_pos));
// 				vol *= 0.05;
// 				audio_file->set_volume(vol);
// 			}
// 		};
// 		movement_logic();
//
// 		// audio_logic();
//
//
//
// 		if (player_pos.y < -2.0f) {
// 			restart_player();
// 		}
//
// 	}
//
// 	editor->add_gui_control("kill everything", &this->to_reset_whole_engine);
//
// 	start_timer_query("update_matrices");
// 	{
// 		ZoneScopedN("UPDATE MATRICES");
//
// 		for (std::pair<const long, WEntity*> game_object : this->entitties) {
// 			// long trippy_obj_id = trippy_obj.get()->game_obj_id;
// 			// if(game_object.second->obj_type == ObjType::IcosaTest) {
// 			// if(game_object.first == trippy_obj_id) {
// 			// 	std::cout << "amogus";
// 			// }
// 			game_object.second->recalc_matrices();
// 		}
// 	}
//
// 	// ------------------------------- //
// 	// ----------- TICKING ----------- //
// 	// ------------------------------- //
// 	{
// 		ZoneScopedN("PHYSICS TICK");
// 		for (auto& game_object : this->entitties) {
// 			if (game_object.second->tick_function) {
// 				game_object.second->tick_function();
// 			}
// 		}
// 		this->physics.tick();
// 	}
//
//
// 	bool aa;
// 	editor->add_gui_control("NOTIFY PRESIDENT", &aa, {
// 		.callback = []() {
// 			// Globals::log->log();
// 			// int amog = __LINE__;
// 			// const char* amoga = __FILE__;
// 			// Globals::log->log_info(__LINE__, __FILE__, "amog");
// 			wlog_info("amog\n");
// 		}
// 	});
// 	// ------------------------------- //
// 	// ----------- RENDER ----------- //
// 	// ------------------------------- //
// 	{
// 		ZoneScopedN("RENDER COMMANDS");
// 		start_timer_query("frame_start");
//
// 		// ------------- RENDER ------------ //
// 		// ------------- RENDER ------------ //
// 		// ------------- RENDER ------------ //
// 		// ------------- RENDER ------------ //
// 		// ------------- RENDER ------------ //
// 		// ------------- RENDER ------------ //
//
// 		glMemoryBarrier(GL_ALL_BARRIER_BITS);
//
// 		start_timer_query("sun");
//
// 		for (auto id_and_game_object : entitties) {
// 			WEntity* game_object = id_and_game_object.second;
// 			if (game_object->shader_prog && game_object->model_node) {
// 				this->drawer_mdi->push(game_object, false);
// 			}
// 			// game_object->draw();
// 		}
// 		this->drawer_mdi->upload_verts();
//
//
// 		// ------ SUN ----- //
//
// 		{
// 			ZoneScopedN("SUN");
// 			// light_sun->calc_matrices();
// 			// float* buff_ptr = (float*)this->shared_ssbo->cpu_data;
// 			// for (int i = 0; i < 16; i++) {
// 			// 	(buff_ptr)[256 + i] = (&light_sun->view_mat[0][0])[i];
// 			// 	(buff_ptr)[256 + 16 + i] = (&light_sun->proj_mat[0][0])[i];
// 			// }
// 			// glNamedBufferSubData(this->shared_ssbo->pid, 0, (256 + 32) * 4, (void*)buff_ptr);
//
//
// 			// glEnable(GL_CULL_FACE); // increases perf
// 			glDisable(GL_CULL_FACE);
// 			glCullFace(GL_BACK);
// 			glEnable(GL_DEPTH_TEST);
//
//
// 			// for (auto shader : this->shader_manager->shader_programs) {
// 			v.prog_thing->use();
// 			v.prog_thing->setUniform("is_shadow", true);
// 			v.prog_thing->setUniform("mdi_uniforms_buff", this->drawer_mdi->uniforms_buff);
//
// 			// shader->setUniform("is_shadow", true);
// 			// }
//
// 			// if(false)
// 			for (int i = 0; i <= alloc_lights.max_slot; i++) {
// 				if (alloc_lights.slot_active[i]) {
// 					v.prog_thing->setUniform("curr_rendering_light", i);
// 					Light& light = alloc_lights.arr[i];
// 					if (light.type == LightType::DIRECTIONAL) {
// 						light.fb->bind();
// 						light.fb->clear();
// 						v.prog_thing->use();
//
// 						// glProgramUniform1i(v.prog_thing->pid, glGetUniformLocation(v.prog_thing->pid, "is_shadow"), 1);
// 						// editor->gui_dbg_print_msg("mogus");
// 						// this->drawer_mdi->flush_draw(false);
// 						this->drawer_mdi->draw();
// 					} else if (light.type == LightType::POINT) {
// 						v.prog_thing->setUniform("curr_rendering_light", i);
// 						// light.fb->clear();
// 						// for(int face = 0; face < 6; face++) {
// 						// 		light.fb->bind_layer(face);
// 						// }
//
// 						for (int face = 0; face < 6; face++) {
// 							light.fb->bind_layer(face);
// 							light.fb->clear_layer(face);
// 							v.prog_thing->setUniform("spot_sublight_idx", face);
// 							this->drawer_mdi->draw();
// 						}
//
//
// 					}
// 					// for (auto id_and_game_object : entitties) {
// 					// 	WEntity* game_object = id_and_game_object.second;
// 					// 	if (game_object->shader_prog && game_object->shader_prog->shadow_map_variation) {
// 					// 		game_object->shader_prog->shadow_map_variation->use();
// 					// 		game_object->shader_prog->shadow_map_variation->setUniform("curr_rendering_light", i);
// 					// 	}
// 					// 	// game_object->draw(0, 0, 0, 0, 0, 1);
// 					// }
// 				}
// 			}
//
// 			v.prog_thing->setUniform("is_shadow", false);
//
// 			// for (auto shader : this->shader_manager->shader_programs) {
// 			// shader->setUniform("is_shadow", false);
// 			// }
//
// 			// for (int i = 0; i < 16; i++) {
// 			// 	(buff_ptr)[256 + i] = this->camera->V.vals[i];
// 			// 	(buff_ptr)[256 + 16 + i] = this->camera->P.vals[i];
// 			// }
// 			// // glNamedBufferSubData(this->shared_ssbo->pid, 4 * 256, 32 * 4, (void*)buff_ptr);
// 			// glNamedBufferSubData(this->shared_ssbo->pid, 0, (256 + 32) * 4, (void*)buff_ptr);
//
// 		}
//
// 		// hdri_tex->generate_mipmap();
//
// 		// v.prev_frame_gi_tex->clear();
//
//
// 		start_timer_query("clean dbg");
// 		{
// 			v.prog_clean_dbg->use();
// 			v.prog_clean_dbg->dispatch_compute(1, 1, 1);
// 			glMemoryBarrier(GL_ALL_BARRIER_BITS);
// 			v.dbg_tex->clear();
// 		}
//
// 		// ------ GBUFF ----- //
// 		start_timer_query("draw");
// 		default_fb->clear();
// 		{
// 			glEnable(GL_CULL_FACE);
// 			glCullFace(GL_BACK);
// 			glEnable(GL_DEPTH_TEST);
// 			v.fb_G->bind();
// 			v.fb_G->clear(0, 0, 0, 0);
//
//
// 			v.prog_thing->use();
// 			v.prog_thing->setUniform("mdi_uniforms_buff", this->drawer_mdi->uniforms_buff);
// 			v.prog_thing->setUniform("is_shadow", false);
//
//
// 			// this->drawer_mdi->flush_draw();
// 			this->drawer_mdi->draw();
//
// 			// prog_march->use();
// 			// glDrawArrays(GL_TRIANGLES, 0, 6);
//
// 			glDisable(GL_DEPTH_TEST);
// 			glDisable(GL_CULL_FACE);
// 			// glDepthMask(GL_FALSE);
// 		}
//
// 		this->drawer_mdi->reset();
//
// 		// ------ DI ----- //
// 		start_timer_query("DI");
// 		{
// 			v.prog_di->use();
//
// 			v.prog_di->setUniform("light_depth_tex", v.light_sun->fb->depth_texture);
// 			v.prog_di->setUniform("light_view_mat", v.light_sun->view_mat);
// 			v.prog_di->setUniform("light_proj_mat", v.light_sun->proj_mat);
// 			v.prog_di->setUniform("light_dir", v.light_sun->dir);
//
//
// 			v.prog_di->setUniform("hdri_tex", v.hdri_tex);
// 			v.prog_di->setUniform("gi_tex", v.fb_GI->get_front_textures_at(0));
// 			v.prog_di->setUniform("prev_gi_tex", v.prev_frame_gi_tex);
// 			v.prog_di->setUniform("col_tex", v.fb_G->get_front_textures_at(0));
// 			v.prog_di->setUniform("norm_mat_tex", v.fb_G->get_front_textures_at(1));
// 			v.prog_di->setUniform("depth_tex", v.fb_G->get_front_depth());
//
// 			v.fb_DI->bind();
// 			v.fb_DI->clear();
// 			glDrawArrays(GL_TRIANGLES, 0, 6);
//
// 			glMemoryBarrier(GL_ALL_BARRIER_BITS);
// 			glTextureBarrier();
// 		}
//
// 		start_timer_query("Add GI and DI");
// 		if (v.add_prev_di_and_gi) {
// 			v.fb_GI_plus_DI->bind();
// 			v.fb_GI_plus_DI->clear();
// 			v.prog_add_gi_and_di->use();
// 			v.prog_add_gi_and_di->setUniform("prev_gi_tex", v.prev_frame_gi_tex);
// 			v.prog_add_gi_and_di->setUniform("prev_di_tex", v.fb_DI->get_back_textures_at(0));
// 			glDrawArrays(GL_TRIANGLES, 0, 6);
// 		}
//
//
// 		// glMemoryBarrier(GL_ALL_BARRIER_BITS);
// 		// ------ GI ----- //
// 		start_timer_query("GI");
// 		{
// 			v.prog_gi_comp->use();
//
// 			v.prog_gi_comp->setUniform("compute_subdiv", v.compute_subdiv);
// 			v.prog_gi_comp->setUniform("light_depth_tex", v.light_sun->fb->depth_texture);
// 			v.prog_gi_comp->setUniform("light_view_mat", v.light_sun->view_mat);
// 			v.prog_gi_comp->setUniform("light_proj_mat", v.light_sun->proj_mat);
// 			v.prog_gi_comp->setUniform("light_dir", v.light_sun->dir);
//
//
// 			v.prog_gi_comp->setUniform("add_prev_di_and_gi", v.add_prev_di_and_gi);
// 			if (v.add_prev_di_and_gi) {
// 				v.prog_gi_comp->setUniform("prev_gi_tex", v.fb_GI_plus_DI->get_front_textures_at(0));
// 			} else {
// 				v.prog_gi_comp->setUniform("di_tex", v.fb_DI->get_back_textures_at(0));
// 				v.prog_gi_comp->setUniform("prev_gi_tex", v.prev_frame_gi_tex);
// 			}
//
//
// 			// editor->gui_dbg_print_msg(std::string("") + std::to_string(v.hdri_tex->bindless_idx) );
// 			v.prog_gi_comp->setUniform("hdri_tex", v.hdri_tex);
// 			v.prog_gi_comp->setUniform("gi_tex", v.fb_GI->get_front_textures_at(0));
// 			v.prog_gi_comp->setUniform("col_tex", v.fb_G->get_front_textures_at(0));
// 			v.prog_gi_comp->setUniform("norm_mat_tex", v.fb_G->get_front_textures_at(1));
// 			v.prog_gi_comp->setUniform("depth_tex", v.fb_G->get_front_depth());
//
// 			if (!v.compute_subdiv) {
// 				for (int iter = 0; iter < 4; iter++) {
// 					v.prog_gi_comp->setUniform("iter", iter);
// 					v.prog_gi_comp->dispatch_compute(WEngine->RESX / 2, WEngine->RESY / 2, 1);
// 					glMemoryBarrier(GL_ALL_BARRIER_BITS);
// 				}
// 			} else {
// 				for (int iter = 0; iter < 4 * 4; iter++) {
// 					v.prog_gi_comp->setUniform("iter", iter);
// 					v.prog_gi_comp->dispatch_compute(WEngine->RESX / 4, WEngine->RESY / 4, 1);
// 					glMemoryBarrier(GL_ALL_BARRIER_BITS);
// 				}
// 			}
//
// 			glMemoryBarrier(GL_ALL_BARRIER_BITS);
// 			glTextureBarrier();
// 		}
//
// 		// ------ GI reproj ----- //
// 		start_timer_query("GI reproj");
// 		{
// 			v.fb_GI_reproj->bind();
// 			v.fb_GI_reproj->clear();
//
// 			v.prog_gi_reproj->use();
//
// 			v.prog_gi_reproj->setUniform("hdri_tex", v.hdri_tex);
// 			v.prog_gi_reproj->setUniform("movec_tex", v.fb_G->get_front_textures_at(2));
// 			v.prog_gi_reproj->setUniform("sun_pos", v.fb_G->get_front_textures_at(1));
// 			v.prog_gi_reproj->setUniform("norm_mat_tex", v.fb_G->get_front_textures_at(1));
// 			v.prog_gi_reproj->setUniform("depth_tex", v.fb_G->get_front_depth());
// 			v.prog_gi_reproj->setUniform("depth_tex_prev", v.fb_G->get_back_depth());
// 			v.prog_gi_reproj->setUniform("norm_mat_tex_prev", v.fb_G->get_back_textures_at(1));
// 			v.prog_gi_reproj->setUniform("prev_gi_tex", v.prev_frame_gi_tex);
// 			// prog_gi_reproj->setUniform("gi_tex", fb_GI->textures[0]);
// 			v.prog_gi_reproj->setUniform("gi_tex", v.fb_GI->get_front_textures_at(0));
// 			glDrawArrays(GL_TRIANGLES, 0, 6);
// 		}
// 		glMemoryBarrier(GL_ALL_BARRIER_BITS);
//
// 		// ------ TAA ----- //
// 		start_timer_query("taa");
// 		{
// 			v.fb_taa->bind();
// 			v.fb_taa->clear();
//
// 			v.prog_taa->use();
// 			v.prog_taa->setUniform("hdri_tex", v.hdri_tex);
// 			// prog_taa->setUniform("taa_hist_tex", (*fb_taa->get_back_textures())[0]);
// 			v.prog_taa->setUniform("movec_tex", v.fb_G->get_front_textures_at(2));
// 			v.prog_taa->setUniform("taa_hist_tex", v.fb_taa->get_back_textures_at(0));
// 			v.prog_taa->setUniform("col_tex", v.fb_G->get_front_textures_at(0));
// 			v.prog_taa->setUniform("dbg_gi_tex", v.fb_GI->get_front_textures_at(0));
// 			// inttasdg
//
// 			v.prog_taa->setUniform("gi_tex", v.fb_GI_reproj->get_front_textures_at(0));
// 			v.prog_taa->setUniform("prev_gi_tex", v.prev_frame_gi_tex);
// 			v.prog_taa->setUniform("di_tex", v.fb_DI->get_front_textures_at(0));
// 			v.prog_taa->setUniform("norm_tex", v.fb_G->get_front_textures_at(1));
// 			v.prog_taa->setUniform("depth_tex", v.fb_G->get_front_depth());
// 			glDrawArrays(GL_TRIANGLES, 0, 6);
// 		}
// 		glMemoryBarrier(GL_ALL_BARRIER_BITS);
//
// 		// ------ Bloom ----- //
// 		// start_timer_query("bloom");
// 		// {
// 		// 	pass_bloom->run(fb_taa);
// 		// }
//
//
// 		// ------ Post ----- //
// 		start_timer_query("post");
// 		{
//
// 			default_fb->bind();
// 			default_fb->clear(0, 0, 0, 0);
// 			v.prog_post->use();
// 			v.prog_post->setUniform("taa_tex", v.fb_taa->get_front_textures_at(0));
//
// 			v.prog_post->setUniform("hdri_tex", v.hdri_tex);
// 			// prog_post->setUniform("gi_tex", (*fb_GI_reproj->get_front_textures())[0]);
// 			v.prog_post->setUniform("gi_tex", v.fb_GI_reproj->get_front_textures_at(0));
// 			v.prog_post->setUniform("prev_gi_tex", v.prev_frame_gi_tex);
// 			v.prog_post->setUniform("depth_tex", v.fb_G->get_front_depth());
// 			// prog_post->setUniform("pt_light", pt_light->fb->get_front_depth());
//
// 			glDrawArrays(GL_TRIANGLES, 0, 6);
// 		}
// 		glMemoryBarrier(GL_ALL_BARRIER_BITS);
//
// 	}
//
// 	// ------ Text ----- //
// 	{
// 		ZoneScopedN("UI");
//
//
// 		score_text.text = "";
// 		score_text.text += std::to_string(int(v.score));
// 		score_text.text += ":";
// 		score_text.text += std::to_string(int(glm::fract(v.score) * 100));
// 		text_drawer->draw(score_text);
// 		text_drawer->flush();
//
// 		// glLineWidth(this->RESY*0.1);
// 		glPointSize(this->RESY*0.1);
// 		drawer_2d->flush_points();
// 		glPointSize(this->RESY*0.02);
// 		// glPoint
// 		drawer_2d->push_vert({
// 			.pos = glm::vec2(0,0),
// 			.uv = glm::vec2(-1,-1),
// 			.color = glm::vec4(1,1,1,0.5)
// 		});
// 		// for(int i = 0; i < 100; i++) {
// 		// }
// 		drawer_2d->flush_points();
//
//
// 		// auto get_text = [](UIElem* elem) -> TextDescriptor& {return ((UIElemText*)elem)->text;};
// 		if (io->get_key(Key::Esc).just_pressed) {
// 			v.start_menu->toggle();
// 		}
//
// 		v.start_menu->run();
// 		drawer_3d->flush();
// 		drawer_2d->flush_quads();
// 		{
// 			text_drawer->flush();
// 		}
//
// 	}
// 	// ------ End ----- //
// 	{
// 		ZoneScopedN("END RENDER");
// 		start_timer_query("frame_end");
// 		editor->depth_texture = v.fb_G->get_front_depth();
// 	}
//
// 	{
// 		ZoneScopedN("MORE END OF RENDER");
// 		audio_mixer->update_player(camera->pos, camera->dir, v.player->get_vel() * 10.0f);
//
// 		drawer_3d->reset();
// 		drawer_2d->reset();
// 		text_drawer->reset_end_of_frame();
//
// 	}
//
// }

